<html>
<head>

<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
<script type="text/javascript" src="jquery-1.10.2.js"></script>
<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
<script type="text/javascript" src="calculationlib/polynomial.js"></script>
<script type="text/javascript" src="calculationlib/mathhelper.js"></script>

<style>
.edit-text {
  display: none;
}
.label-g .mathtex {
  float: left;
}
.mathtex {
  padding: 5px;
}
td {
  padding: 15px;
}
</style>

<script>

var FieldExtend = function(gp){
  $this = this;
  $this.GenPoly = gp;
  $this.GenPolyPow = gp.Data.length - 1;
  $this.Root = new Polynomial(gp.Data.slice(1), gp.Degree, "\\theta").Multiply(gp.Degree.Inverse(gp.Data[0]), "\\theta");
  $this.Degree = gp.Degree;

  var generatePolynomPow = function(p, c) {
      var data = [];
      c = c || 1;
      data.push(c);
      for (var i = 0; i < p; i++)
        data.push(0);
      return new Polynomial(data, gp.Degree, "\\theta");
    }
  var reduce = function(poly, rootDegree, root) { // x^255, 8, \\theta+1
      if (poly.Data.length - 1 < rootDegree)
        return poly;
      var lowerPart = new Polynomial(poly.Data.slice(poly.Data.length - rootDegree, poly.Data.length), $this.Degree, "\\theta");
      var list = [lowerPart];
      for (var i = 0; i < poly.Data.length - rootDegree; i++){
        var pw = poly.Data.length - i - 1;
        var r = pw % rootDegree;
        var b = parseInt(pw / rootDegree);
        if (poly.Data[i] == 0)
          continue;
		    var coef = poly.Data[i];
        var rp = generatePolynomPow(r);
        var resp = root.Pow(b, "\\theta").Multiply(coef, "\\theta").Multiply(rp, "\\theta");
        if (resp.Data.length - 1 >= rootDegree)
          resp = reduce(resp, rootDegree, root);
        list.push(resp);
      }
      var result = new Polynomial([0], $this.Degree, "\\theta" );
      for (var i = 0; i < list.length; i++) {
        result = result.Add(list[i], "\\theta");
      }
      if (result.Data.length - 1 >= rootDegree)
        result = reduce(result, rootDegree, root);
      return result;
    }
  $this.GetElementPow = function(pow) {
    var poly = generatePolynomPow(pow);
    poly = reduce(poly, $this.GenPolyPow, $this.Root);
    return poly;
    //var r = pow % $this.GenPolyPow;
    //var b = parseInt(pow / $this.GenPolyPow);
    //return { Text: (b > 0 ? "(" + $this.Root.Text + ")^{" + b + "}" : "") + (r > 0 ?" \\theta^{" + r + "}" : "")   };
    return $this.Root.Pow(2, "\\theta");
  }
  $this.Reduce = function(poly) {
	  return reduce(poly, $this.GenPolyPow, $this.Root);
  }
};


var mthhlp = new mathhelper();
var fld;

$(document).ready(function() {
  $('a.edit').click(function() {
    var t = $(this).parent();  // div
	  var l = t.find('.lab');    // label
    var value = l.attr("data-value").trim();
    l.hide();
    t.find('.edit').hide();
	  t.find('.edit-text').show().focus().val(value);
  });
  $('.label-g .edit-text').focusout(function() {
    var t = $(this).parent();
	  $(this).hide();
    var mode = $(this).attr("value-mode");
    var deg = parseInt(eval($(this).attr("data-degree")));
    var l = t.find('.lab');

    var raw =  $(this).val();
    var result = raw;
    if (mode == "polynom") {
      var data = mthhlp.read.polynomial(raw);
      var poly = new Polynomial(data, deg);
      result = poly.Text;
      $(this).attr("data-polynom", poly);
    }
    else if (mode == "matrix") {
      var data = mthhlp.read.matrix(raw);
      var matrix = new Matrix(data);
      result = matrix.ToLatex();
      $(this).attr("data-matrix", matrix);
    }
    l.attr("data-value", raw);
    mthhlp.out.clear(l);
    mthhlp.out.write(l, result);
    l.show();
    t.find('.edit').show();
  });
  $('.label-g .edit-text').trigger('focusout');

  $('#elDegree .edit-text').on('focusout', function() {
	$('#elPolynomial .edit-text').trigger('focusout');
  });
  $('#btnCalculateField').on('click', function() {
    var degree = parseInt($("#elDegree .edit-text").val());
    var genPoly = new Polynomial(mthhlp.read.polynomial($("#elPolynomial .edit-text").val()), degree);
    var fieldExtend = new FieldExtend(genPoly);
    fld = fieldExtend;

    var result = $("#result");

    mthhlp.out.clear(result);

    mthhlp.out.write(result, "\\theta^{" + fieldExtend.GenPolyPow + "}=" + fieldExtend.Root.Text);

    //mthhlp.out.write(result, "\\theta^{" + 63 + "} = " + fieldExtend.GetElementPow(63).Text);
    mthhlp.out.write(result, " ");

	var field = { };
	var maxPow = Math.pow(degree, fieldExtend.GenPolyPow)-1;
    for (var i = 1; i <= maxPow; i++) {
	  var element = fieldExtend.GetElementPow(i);
      mthhlp.out.write(result, "\\theta^{" + i + "} = " + element.Text);
	  field[i] = element;
    }
	$("#result").append("<hr />");
	for (var i = 1; i < Math.ceil((maxPow) / 2.0); i++) {
	  var el = field[i];
	  var inv = field[maxPow-i];
	  var res = fieldExtend.Reduce(el.Multiply(inv));
	  mthhlp.out.write(result, "\\theta^{" + i +  "} \\times \\theta^{" + (maxPow-i)  + "} = (" + el.Text + ")\\times(" + inv.Text + ") = " + res.Text);
	}

  });
});

</script>

</head>
<body>


<table>
  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Cisim Derecesi(\(q\)): </label>
    </td>
    <td>
      <div class="label-g" id="elDegree">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value = "2" />
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>

  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Üreteç Polinom (\(f(x)\)): </label>
    </td>
    <td>
      <div class="label-g" id="elPolynomial">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value="x^8 +x^4+x^3+x^2+1" value-mode="polynom" data-degree="$('#elDegree .edit-text').val()"/>
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>
  <tr style="display: none;">
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Üreteç Matris (\(G\)): </label>
    </td>
    <td>
      <div class="label-g">
      <label for="elab" class="lab"></label>
      <textarea class="edit-text" id = "elab" rows="5" value-mode="matrix" data-degree="2">
1 1 1 1 1 1 1
1 0 0 0 1 0 1
1 1 0 0 0 1 0
0 1 1 0 0 0 1
      </textarea>
      <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>
</table>

<input type="button" id="btnCalculateField" value="Hesapla" />

<div id="result"  style="padding: 20px">
</div>

</body>
</html>
